import greenfoot.*;

public class Level2 extends Level
{
    Scroller scroller; // for the Scroller object
    
    public Level2()
    {
        super(600, 510, 1, false);
        // the background
        getBackground().setColor(new java.awt.Color(224, 224, 255));
        getBackground().fill();
        // the scroller object
        scroller = new Scroller(this, null, 30*map[0].length(), 30*map.length);
    }
    
    public void setFields()
    {
        // the level number
        LevelControl.setLevel(2);
        // the level map
        map = new String[]
        {
            "                                        ",
            "                                        ",
            "                                        ",
            "                                       p",
            "w                                      w",
            "ww                                    ww",
            "www   www    www        www    www   www",
            "                    o                   ",
            "                   ww                   ",
            "                  wwww                  ",
            "                 wwwwww                 ",
            "     www   www  wwwwwwww  www   www     ",
            "ww                                    ww",
            "www                                  www",
            "wwww                                wwww",
            "wwwww                              wwwww",
            "wwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwwww"
        };
    }
    
    // next level
    public void nextLevel()
    {
        addObject(new GameOver("YOU\n\nWIN"), 300, 240);
        Greenfoot.stop();
    }
    
    // current level
    public void resetLevel()
    {
        Greenfoot.setWorld(new Level2());
    }
    
    // scroll control and check for next level
    public void act()
    {
        if (player.getWorld() == null) return; // do nothing if player not in world
        
        // scroll limits
        int loX = 100; // main actor left limit before scrolling
        int hiX = getWidth()-100; // main actor right limit before scrolling
        // determine horizontal scroll amount
        int dsx = 0;
        if (player.getX() < loX) dsx = player.getX()-loX;
        if (player.getX() > hiX) dsx = player.getX()-hiX;
        // scroll
        scroller. scroll(dsx, 0);
        // check for next level
        if (player.getX() == 8 && player.getY() == 112) nextLevel();
    }
    
    public void started()
    {
        removeObjects(getObjects(GameOver.class));
        if (player.getWorld() == this) removeObject(player);
        addObject(player, 39*25+12, 2*25+12);
    }
}