import greenfoot.*;
import java.awt.Color;

public class Orb extends GQActor
{
    public Orb()
    {
        // the image
        GreenfootImage image = new GreenfootImage(20, 20);
        image.fillOval(0, 0, 20, 20);
        image.setColor(Color.orange);
        image.fillOval(2, 2, 16, 16);
        image.setColor(Color.black);
        image.drawLine(10, 0, 10, 20);
        image.drawLine(0, 10, 20, 10);
        setImage(image);
        // the Q settings
        setVX(191);
        setGravity(100);
        setMaximumSpeed(191);
        setObstacles(Block.class);
    }

    public void act()
    {
        // move (tumble and roll)
        int qr = getQR();
        setRotation(0); // temporarily set rotation to zero for movement
        moveVertically();
        moveHorizontally();
        setQRotation(qr); // restores rotation
        // turn
        turn(600*(int)Math.signum(getVX()));
        // shoot
        if (getRotation()%180 == 0)
        {
            Bullet bullet = new Bullet();
            bullet.setRotation(getRotation());
            getWorld().addObject(bullet, getX(), getY());
            bullet.move(15);
        }
    }
    
    // act on obstacle intersecting
    protected void touching(Actor actor, int axis)
    {
        // while moving horizontally
        if (axis == 0)
        {
            // bounce
            int lastVX = getVX();
            super.touching(actor, axis);
            setVX(-lastVX);
        }
        else
        // while moving vertically
        {
            super.touching(actor, axis);
        }
    }
    
    // the bullets an orb creates
    public class Bullet extends Actor
    {
        public Bullet()
        {
            // the image
            setImage(new GreenfootImage(10, 2));
            getImage().fill();
        }
        
        // movement and removal
        public void act()
        {
            move(5);
            if (getX() < -getWorld().getWidth() ||
                getX() > 2*getWorld().getWidth() ||
                isTouching(Block.class))
            {
                getWorld().removeObject(this);
            }
        }
    }
}