import greenfoot.*;

public class Particle extends GQActor
{    
    public Particle(int vel, int dir)
    {
        // the image
        GreenfootImage image = new GreenfootImage(6, 6);
        int[] xs = new int[3];
        int[] ys = new int[3];
        for (int i=0; i<3; i++)
        {
            xs[i] = 1+Greenfoot.getRandomNumber(3);
            ys[i] = 1+Greenfoot.getRandomNumber(3);
            int n = Greenfoot.getRandomNumber(2)*5;
            if (Greenfoot.getRandomNumber(2) == 0) xs[i] = n; else ys[i] = n;
        }
        int r = Greenfoot.getRandomNumber(128)+127;
        int g = Greenfoot.getRandomNumber(128)+127;
        int b = Greenfoot.getRandomNumber(128)+127;
        int c = Greenfoot.getRandomNumber(3);
        if (c == 0) r = 0; else if (c == 1) g = 0; else b = 0;
        image.setColor(new java.awt.Color(r, g, b));
        image.fillPolygon(xs, ys, 3);
        setImage(image);
        // the Q settings
        vel = vel*(Greenfoot.getRandomNumber(51)+50)/100;
        dir = dir-4000+Greenfoot.getRandomNumber(8001);
        addForce(vel, dir);
        setMaximumSpeed(900);
        setGravity(30);
        setObstacles(Block.class);
        setBoundedAction(QActor.REMOVE, 5);
    }

    public void act()
    {
        // move
        moveVertically();
        moveHorizontally();
        // reemove
        if (getGroundActor() != null
            || getX() < -5
            || getX() > getWorld().getWidth()+4)
                getWorld().removeObject(this);
    }
}